/************************************************************************
** MODULE INFORMATION **
************************
** FILE NAME:          netnames.h
** SYSTEM NAME:        Netmon
** TYPE NAME:          address/port resolution
** ORIGINAL AUTHOR(S): L. Th. Weerpas & W. Haverhals
** VERSION NUMBER:     1.0
** CREATION DATE:      1992/6/9
**
** DESCRIPTION:        .
*************************************************************************
** CHANGES INFORMATION **
*************************
** REVISION:           $Revision$
** WORKFILE:           $Workfile$
** LOGINFO:            $Log$
*************************************************************************
** COPYRIGHT           (c) 1992
**                     L. Th. Weerpas & W. Haverhals
**                     All rights reserved.
**
** NOTICE              Redistribution  and use in source and binary forms
**                     are  permitted  provided  that the above copyright
**                     notice  and  this  paragraph are duplicated in all
**                     such forms and that any documentation, advertising
**                     materials,  and  other  materials  related to such
**                     distribution and use acknowledge that the software
**                     was  developed  by  above  mentioned  authors. The
**                     name(s)  of the authors may not be used to endorse
**                     or  promote  products  derived  from this software
**                     without  specific  prior  written permission.
**                     THIS  SOFTWARE  IS  PROVIDED ``AS IS'' AND WITHOUT
**                     ANY  EXPRESS  OR  IMPLIED  WARRANTIES,  INCLUDING,
**                     WITHOUT  LIMITATION,  THE  IMPLIED  WARRANTIES  OF
**                     MERCHANTIBILITY   AND  FITNESS  FOR  A  PARTICULAR
**                     PURPOSE.
************************************************************************/

#ifndef _NETNAMES_H
#define _NETNAMES_H

#include <netdb.h>

#define NET_TCP  (0)
#define NET_UDP  (1)

#define MRU_LEN  (2*MTS)
#define MRU_TOP  (MTS/2)

typedef struct servent      SERVENT;
typedef struct hostent      HOSTENT;
typedef struct _netaddr     NETADDR;
typedef struct _netaddrent  NETADDRENT;
typedef struct _netport     NETPORT;
typedef struct _netportent  NETPORTENT;

struct _netaddr
{
    NETADDRENT  *head;
    NETADDRENT  *tail;
    u_short      len;
    u_short      max;
    u_long       hits;        /* nr of search hits */
    u_long       misses;      /* nr of search misses */
    u_long       nores;       /* nr misses with no NAME resolution */
    u_long       fronts;      /* nr of moves to front */
};

struct _netaddrent
{
    NETADDRENT  *prev;
    NETADDRENT  *next;
    u_long       addr;
    char         name[ MAXHOSTNAMELEN+1 ];
};

/*
 * port structs
 */

struct _netport
{
    NETPORTENT  *head;
    NETPORTENT  *tail;
    u_short      len;
    u_short      max;
                              /* STATISTICS ---------------------- */
    u_long       hits;        /* nr of search hits                 */
    u_long       misses;      /* nr of search misses               */
    u_long       nores;       /* nr misses with no NAME resolution */
    u_long       fronts;      /* nr of elements moves to front     */
};

struct _netportent
{
    NETPORTENT  *prev;
    NETPORTENT  *next;
    u_short      port;
    char         name[ MAXHOSTNAMELEN ];
};

/*
 * externs
 */

#ifndef _NETNAMES_C
extern NETADDR mru;
extern NETPORT mru_udp;                 /* tcp port list */
extern NETPORT mru_tcp;                 /* udp port list */
#endif

/*
 * prototypes
 */

void  NetNameOpen( void );
char *AddrLookup( register u_long addr );
char *PortLookup( register u_short port, int proto );

#endif  /* end of netnames.h, do not remove */


