/************************************************************************
** MODULE INFORMATION **
************************
** FILE NAME:          nettcpso.h
** SYSTEM NAME:        Netmon
** TYPE NAME:          network TCP sockets
** ORIGINAL AUTHOR(S): L. Th. Weerpas & W. Haverhals
** VERSION NUMBER:     1.0
** CREATION DATE:      1992/6/9
**
** DESCRIPTION:        header file for nettcpso.c
*************************************************************************
** CHANGES INFORMATION **
*************************
** REVISION:           $Revision$
** WORKFILE:           $Workfile$
** LOGINFO:            $Log$
*************************************************************************
** COPYRIGHT           (c) 1992
**                     L. Th. Weerpas & W. Haverhals
**                     All rights reserved.
**
** NOTICE              Redistribution  and use in source and binary forms
**                     are  permitted  provided  that the above copyright
**                     notice  and  this  paragraph are duplicated in all
**                     such forms and that any documentation, advertising
**                     materials,  and  other  materials  related to such
**                     distribution and use acknowledge that the software
**                     was  developed  by  above  mentioned  authors. The
**                     name(s)  of the authors may not be used to endorse
**                     or  promote  products  derived  from this software
**                     without  specific  prior  written permission.
**                     THIS  SOFTWARE  IS  PROVIDED ``AS IS'' AND WITHOUT
**                     ANY  EXPRESS  OR  IMPLIED  WARRANTIES,  INCLUDING,
**                     WITHOUT  LIMITATION,  THE  IMPLIED  WARRANTIES  OF
**                     MERCHANTIBILITY   AND  FITNESS  FOR  A  PARTICULAR
**                     PURPOSE.
************************************************************************/

#ifndef _NETTCPSO_H
#define _NETTCPSO_H

/*
 * extra includes
 */

#include "nettcp.h"
#include <pwd.h>
#include <sys/proc.h>
#include <sys/user.h>
#include <netinet/tcp_fsm.h>
#include <sundev/mbvar.h>
#include "netnames.h"

/*
 * defines, typedefs, ...
 */

#define MTS              (60)
#define MAX_SO           (200)
#define SORTED
#define RESOLVER

#define spl3()           (0)
#define splx( x )        (x)

typedef struct inpcb     INPCB;
typedef struct socket    SOCKET;
typedef struct tcpcb     TCPCB;
typedef struct proc      PROCESS;
typedef struct in_addr   INADDR;

typedef struct _nettcpso NETTCPSO;
struct _nettcpso
{
    NETTCPSO *next;
    INPCB     ipcb;       /* Internet pcb          */
    int       sockok;     /* socket is valid flag  */
    SOCKET    sock;       /* socket                */
    int       tcbok;      /* tcb    is valid flag  */
    TCPCB     ttcb;       /* TCP tcb               */
    int       rprocok;    /* proces is valid flag  */
    PROCESS   rprc;       /* receiving process     */
    int       sprocok;    /* proces is valid flag  */
    PROCESS   sprc;       /* sending process       */
};

/*
 * GLOBAL externs
 */

#ifndef _NETTCPSO_C
extern MODFUNC modtcpso;
#endif

/*
 * prototypes
 */

#ifdef _NETTCPSO_C
void TcpSoInit  ( void );
void TcpSoText  ( int x, int y );
void TcpSoUpdate( int x, int y );
#endif

char *GetUserName   ( int uid, char *buf );
char *GetProcName   ( PROCESS *proc, char *buf );
void  SockAdrPortOut( struct in_addr *inadr , u_short inport, int proto );
void  SockStateInfo ( short   state );
void  SockOptions   ( SOCKET *pso );
void  SockBufSize   ( SOCKET *pso );

#endif /* end of nettcpso.h */


