/************************************************************************
** MODULE INFORMATION **
************************
** FILE NAME:          netterm.h
** SYSTEM NAME:        Netmon
** TYPE NAME:          Terminal I/O
** ORIGINAL AUTHOR(S): L. Th. Weerpas & W. Haverhals
** VERSION NUMBER:     1.0
** CREATION DATE:      1992/6/9
**
** DESCRIPTION:        general header file for all net modules that use
**                     (simple) terminal I/O
*************************************************************************
** CHANGES INFORMATION **
*************************
** REVISION:           $Revision$
** WORKFILE:           $Workfile$
** LOGINFO:            $Log$
*************************************************************************
** COPYRIGHT           (c) 1992
**                     L. Th. Weerpas & W. Haverhals
**                     All rights reserved.
**
** NOTICE              Redistribution  and use in source and binary forms
**                     are  permitted  provided  that the above copyright
**                     notice  and  this  paragraph are duplicated in all
**                     such forms and that any documentation, advertising
**                     materials,  and  other  materials  related to such
**                     distribution and use acknowledge that the software
**                     was  developed  by  above  mentioned  authors. The
**                     name(s)  of the authors may not be used to endorse
**                     or  promote  products  derived  from this software
**                     without  specific  prior  written permission.
**                     THIS  SOFTWARE  IS  PROVIDED ``AS IS'' AND WITHOUT
**                     ANY  EXPRESS  OR  IMPLIED  WARRANTIES,  INCLUDING,
**                     WITHOUT  LIMITATION,  THE  IMPLIED  WARRANTIES  OF
**                     MERCHANTIBILITY   AND  FITNESS  FOR  A  PARTICULAR
**                     PURPOSE.
************************************************************************/

#ifndef _NETTERM_H
#define _NETTERM_H

#include <sgtty.h>

/*
 * defines, typedefs, ...
 */

#define BUFSIZE_STDOUT (162*60)

#define STDIN          (0)
#define STDOUT         (1)
#define STDERR         (2)

typedef struct modtext MODTEXT;
struct modtext
{
    int   row;
    int   col;
    void *ptr;
};

/*
 * GLOBAL externs
 */

#ifndef _NETTERM_C
extern int    tdim_width;
extern int    tdim_height;
extern double termcharcount;
#endif

/*
 * prototypes
 */

#ifdef _NETTERM_C
char *tgetstr( char*, char **);
char *tgoto( char*, int, int );
#endif

void  TermOpen( void );
void  TermClose( void );
void  TermClear( void );
void  TermClearToEnd( void );
int   TermSetXY( int x, int y );
void  TermSetHome( void );
char *TermPutCap( char *str );
char *TermPrint( char *string );
void  TermValue( MODTEXT *tv, int xoffs, int yoffs, int length );
void  putstdout( char c );
void  tprintf( int x, int y, char *format, ... );
void  cprintf( char *format, ... );
void  eprintf( char *format, ... );

#endif /* end of netterm.h */







