/************************************************************************
** MODULE INFORMATION **
************************
** FILE NAME:          netudpso.h
** SYSTEM NAME:        Netmon
** TYPE NAME:          UDP sockets
** ORIGINAL AUTHOR(S): L. Th. Weerpas & W. Haverhals
** VERSION NUMBER:     1.0
** CREATION DATE:      1992/6/14
**
** DESCRIPTION:        header file for netudpso.c
*************************************************************************
** CHANGES INFORMATION **
*************************
** REVISION:           $Revision$
** WORKFILE:           $Workfile$
** LOGINFO:            $Log$
*************************************************************************
** COPYRIGHT           (c) 1992
**                     L. Th. Weerpas & W. Haverhals
**                     All rights reserved.
**
** NOTICE              Redistribution  and use in source and binary forms
**                     are  permitted  provided  that the above copyright
**                     notice  and  this  paragraph are duplicated in all
**                     such forms and that any documentation, advertising
**                     materials,  and  other  materials  related to such
**                     distribution and use acknowledge that the software
**                     was  developed  by  above  mentioned  authors. The
**                     name(s)  of the authors may not be used to endorse
**                     or  promote  products  derived  from this software
**                     without  specific  prior  written permission.
**                     THIS  SOFTWARE  IS  PROVIDED ``AS IS'' AND WITHOUT
**                     ANY  EXPRESS  OR  IMPLIED  WARRANTIES,  INCLUDING,
**                     WITHOUT  LIMITATION,  THE  IMPLIED  WARRANTIES  OF
**                     MERCHANTIBILITY   AND  FITNESS  FOR  A  PARTICULAR
**                     PURPOSE.
************************************************************************/

#ifndef _NETUDPSO_H
#define _NETUDPSO_H

/*
 * extra includes
 */

#include "nettcpso.h"
#include "netudp.h"

/*
 * defines, typedefs, ...
 */

typedef struct _netudpso NETUDPSO;
struct _netudpso
{
    INPCB     ipcb;       /* Internet pcb          */
    int       sockok;     /* socket is valid flag  */
    SOCKET    sock;       /* socket                */
    int       rprocok;    /* proces is valid flag  */
    PROCESS   rprc;       /* receiving process     */
    int       sprocok;    /* proces is valid flag  */
    PROCESS   sprc;       /* sending process       */
};

/*
 * GLOBAL externs
 */

#ifndef _NETUDPSO_C
extern MODFUNC modudpso;
#endif

/*
 * prototypes
 */

#ifdef _NETUDPSO_C
void UdpsoInit( void );
void UdpsoText( int x, int y );
void UdpsoUpdate( int x, int y );
#endif

#endif /* end of netudpso.h */















